
//=============================================================================
//
//  File name - controls.ch
//  Created   - RTD  12/05/94  16:51:12
//
//  Copyright (c) 1994  Raymond T. Deal
//
//  Functions:
//
//=============================================================================

#include 'getexit.ch'
#include 'inkey.ch'

#define tC_DIALOG     aSysColors[1]
#define tC_BUTTON     aSysColors[2]
#define tC_BUTLOW     aSysColors[3]
#define tC_BUTHIGH    aSysColors[4]
#define tC_TEXTFIELD  aSysColors[5]
#define tC_GRAYTEXT   aSysColors[6]
#define tC_HOTKEY     aSysColors[7]

#define tC_SHADOW      aSysColors[8]    //'N/N'
#define tC_BOXHEADER   aSysColors[9]    //'W+/B' //'N/W'
#define tC_INACTIVEBOX aSysColors[10]   //'B/W'  //'N/W'
#define tC_ACTIVEBOX   aSysColors[11]   //'W+/B' //"N/W*"
#define tC_MENUCOLOR   aSysColors[12]   //'N/W+*'
#define tC_MENUHILITE  aSysColors[13]   //'W/N'


#define GETTOP           1   // All Controls
#define GETLEFT          2   // All Controls
#define GETBOTTOM        3   // All Controls
#define GETRIGHT         4   // All Controls
#define GETPROMPT        5   // All Controls
#define GETACTION        6   // All Controls
#define GETTYPE          7   // All Controls
#define GETHELPLINE      8   // All Controls
#define GETCOLOR         9   // All Controls
#define GETHOTKEY       10   // All Controls
#define GETCARGO        11   // All Controls

#define GETRADIOARRAY   13   // RadioButtons
#define GETRADIONVAR    14   // RadioButtons
#define GETRADIOACTION  15   // RadioButtons

#define GETBROWSE       13   // BrowseBox
#define GETTAGBLOCK     14   // BrowseBox
#define GETBROWSEACTION 15   // BrowseBox
#define GETHANDLER      16   // BrowseBox
#define GETBARBLOCK     17   // BrowseBox
#define GETBARPOINTER   18   // BrowseBox

#define GETDROPACTION   13   // DropDown
#define GETELEMENT      14   // DropDown
#define GETABROWSE      15   // DropDown
#define GETABROWSIZE    16   // DropDown

#define GETCHKBOXLVAR   13   // CheckBox

#define GETMENUITEM     14   // Menu


#define GETSUPPRESS     13   // PushButtons
#define GETVALIDATE     14   // PushButtons


#define GE_LEAVESUBMENU -90

#define B_YES           1
#define B_NO            2
#define B_OK            9
#define B_CANCEL        10

#xtranslate :oBrowse   => :Cargo\[13\]
#xTranslate :cType     => :Cargo\[7\]
#xTransLate :bAction   => :Cargo\[6\]
#xTransLate :cPrompt   => :Cargo\[5\]
#xTransLate :lValue    => :Cargo\[13\]
#xTransLate :nValue    => :Cargo\[14\]
#xTransLate :cColor    => :Cargo\[9\]
#xTransLate :UserCargo => :Cargo\[11\]

#xTransLate :BrowseRefresh          => :Cargo\[13\]:Refreshall()
#xTransLate :BrowseForcestable      => :Cargo\[13\]:Forcestable()
#xTransLate ReDrawOut(<oGet> )      => DrawButton ( <oGet>:cargo, 1)
#xTransLate ReDrawIn( <oGet> )      => DrawButton ( <oGet>:cargo, 2, .t.)
#xTransLate ReDrawAll( <aGetList> ) => ReDrawGets(<aGetList>)

#xTransLate Box:cColor => aTail(aBoxes)\[8\]
#xTransLate Box:cHeader => aTail(aBoxes)\[5\]

#xTransLate Disable <oMenu> Item <nItem>  ;
            SubItem <nSubItem>            ;
=>                                        ;
<oMenu>:Cargo\[14\]\[<nItem>\]\[4\]\[<nSubItem>\]\[5\] := .t.

#xTransLate Enable <oMenu> Item <nItem>   ;
            SubItem <nSubItem>            ;
=>                                        ;
<oMenu>:Cargo\[14\]\[<nItem>\]\[4\]\[<nSubItem>\]\[5\] := .f.

Memvar nBoxTop
Memvar nBoxLeft
Memvar nBoxBot
Memvar nBoxRight
Memvar cBoxHeader
Memvar aSaveScreen
Memvar aSysColors
MemVar lMouse
MemVar aBoxes
MemVar nSystemSeconds
MemVar lSystemEvent
Memvar nEverySeconds
Memvar bSystemEvent
Memvar l_Controls_Sys

#xTranslate Create DeskTop                               ;
            Header <cHeader>                             ;
            [ Fill Character <cChar>]                    ;
            [ Color <cColor>        ]                    ;
=>                                                       ;
aadd(aSaveScreen, { 0,0,maxrow()+1,maxcol()+1, DrawBox(0,0,maxrow()+1,maxcol()+1,<cHeader>,[<cChar>],.t.,[<cColor>]), <cHeader>, .t. } )

#xTranslate @ <nRow>, <nCol> Get as DialogBox            ;
                             Header <cHeader>            ;
                             Height <nHeight>            ;
                             Length <nLength>            ;
                             [ Color <cColor>   ]        ;
                             [ Fill Character <cChar> ]  ;
                             [ <lVar: Maximize> ]        ;
=>                                                       ;
if (<.lVar.>, (nBoxTop := 0, nBoxLeft := 0, nBoxBot := maxrow(), nBoxRight := maxcol()),(nBoxTop := <nRow>, nBoxLeft := <nCol>, nBoxBot := <nRow>+<nHeight> , nBoxRight := <nCol>+<nLength>-1 )) ;;
cBoxHeader := <cHeader>                                 ;;
aadd(aBoxes, { nBoxTop, nBoxLeft, nBoxBot, nBoxRight, cBoxHeader, [<cChar>],.f.,<cColor>, <.lVar.>  }) ;;
aadd(aSaveScreen, {nBoxTop,nBoxLeft,nBoxBot+1,nBoxRight+2, DrawBox(nBoxTop,nBoxLeft,nBoxBot+1,nBoxRight+2, <cHeader>,[<cChar>],.f.,<cColor>, <.lVar.>), cBoxHeader, .f.  } )

#xTranslate @ <nRow>,<nCol> Get As BrowseBox  [<oName>]  ;
                            Prompt <cPrompt>             ;
                            Browse <oBrowse>             ;
                            Height <nHeight>             ;
                            Length <nLength>             ;
                            [ Color <cColor> ]           ;
                            [ Hotkey <nHotKey,...> ]     ;
                            [ Browse Action <bAction> ]  ;
                            [ KeyHandler <bHandler> ]    ;
                            [ Help <bHelp> ]             ;
                            [ Tag Block <bTagBlock>]     ;
                            [ Vertical Bar Block <bBar>  ;
                            [ Position Pointer At <nPosition> ] ];
=>                                                       ;
aAdd(Getlist, [<oName> := ] GetNew(nBoxTop+<nRow>,nBoxLeft+<nCol>,{||""},"BROWSEBOX") ) ;;
aTail(getlist):cargo := { nBoxTop+<nRow>                 ,;
                          nBoxLeft+<nCol>                ,;
                          nBoxTop+<nRow>+<nHeight>+if(!empty(<cPrompt>),1,0),;
                          nBoxLeft+<nCol>+<nLength>      ,;
                          <cPrompt>                      ,;
                          nil                            ,;
                          'BROWSEBOX'                    ,;
                          <bHelp>                        ,;
                          <cColor>                       ,;
                          {<nHotKey>}                    ,;
                          NIL                            ,;
                          NIL                            ,;
                          <oBrowse>                      ,;
                          <bTagBlock>                    ,;
                          <bAction>                      ,;
                          <bHandler>                     ,;
                          <bBar>                         ,;
                          <nPosition>                    ,;
                          nil                            ,;
                          nil }                          ;;
GetDisplay(aTail(Getlist))                              ;;
_SetUpBrowse(<oBrowse>, nBoxTop, nBoxLeft, <nRow>, <nCol>, <nHeight>, <nLength>, <cPrompt>, <cColor>, <nPosition> )

#xTranslate @ <nRow>,<nCol> Get As PushButton [<oName>]  ;
                            Prompt <cPrompt>             ;
                            [ Color <cColor> ]           ;
                            [ HotKey <nHotKey,...>  ]    ;
                            [ Valid <bValid>    ]        ;
                            [ When <bWhenBlock> ]        ;
                            [ <lVar: SUPPRESSVALID> ]    ;
                            [ <lVar2: VALIDATEALL>  ]    ;
                            [ Help <bHelp> ]             ;
                            Action <bBlock>              ;
=>                                                       ;
AAdd( GetList, [<oName> := ]  GetNew(nBoxTop+<nRow>,nBoxLeft+<nCol>,{||""} , "PUSHBUTTON"):display() ) ;;
atail(getlist):cargo := { nBoxTop+<nRow>                ,;
                          nBoxLeft+<nCol>               ,;
                          nBoxTop+<nRow>+2              ,;
                          nBoxLeft+<nCol>+if(at('~',<cPrompt>) > 0,len(<cPrompt>)-1,len(<cPrompt>))+3,;
                          <cPrompt>                     ,;
                          <bBlock>                      ,;
                          'PUSHBUTTON'                  ,;
                          <bHelp>                       ,;
                          <cColor>                      ,;
                          {<nHotKey>}                   ,;
                          nil                           ,;
                          nil                           ,;
                          <.lVar.>                      ,;
                          <.lVar2.>                     ,;
                          nil                           ,;
                          NIL                           ,;
                          nil                           ,;
                          nil                           ,;
                          nil                           ,;
                          nil }                         ;;
SetGetValid(aTail(GetList),[<bValid>],[<bWhenBlock>])          ;;
GetDisplay(aTail(Getlist))

#xTranslate @ <nRow>,<nCol> Get <cVar> As TextField [<oName>]   ;
                            Prompt <cPrompt>                    ;
                            [ Color <cColor>  ]                 ;
                            [ Picture <cPict> ]                 ;
                            [ Hotkey <nHotKey,...>]             ;
                            [ When <bWhenBlock> ]               ;
                            [ Valid   <bValid>]                 ;
                            [ Help <bHelp> ]                    ;
=>                                                              ;
AAdd( GetList, [<oName> := ] GetNew(nBoxTop+<nRow>,nBoxLeft+<nCol>+if(at('~',<cPrompt>) > 0,len(<cPrompt>)-1,len(<cPrompt>))+1,{|val| if(pcount() > 0, <cVar> := val, <cVar>) } , 'TEXTFIELD', [<cPict>]) ) ;;
atail(getlist):cargo := { nBoxTop+<nRow>                       ,;
                          nBoxLeft+<nCol>                      ,;
                          nBoxTop+<nRow>                       ,;
                          nBoxLeft+<nCol>+if(at('~',<cPrompt>) > 0,len(<cPrompt>)-1,len(<cPrompt>))+len(<cVar>),;
                          <cPrompt>                            ,;
                          NIL                                  ,;
                          'TEXTFIELD'                          ,;
                          <bHelp>                              ,;
                          <cColor>                             ,;
                          {<nHotKey>}                          ,;
                          NIL                                  ,;
                          NIL                                  ,;
                          NIL                                  ,;
                          NIL                                  ,;
                          nil                                  ,;
                          NIL                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil}                                 ;;
SetGetValid(aTail(GetList),[<bValid>],[<bWhenBlock>])          ;;
GetDisplay(aTail(Getlist))

#xTranslate @ <nRow>,<nCol> Get <nVar> As NumField [<oName>]    ;
                            Prompt <cPrompt>                    ;
                            Length <nLen>                       ;
                            [Decimal Place <nPlace>]            ;
                            [ Color <cColor>  ]                 ;
                            [ Hotkey <nHotKey,...>]             ;
                            [ When <bWhenBlock>]                ;
                            [ Valid   <bValid>]                 ;
                            [ Help <bHelp> ]                    ;
=>                                                              ;
AAdd( GetList, [<oName> := ] GetNew(nBoxTop+<nRow>,nBoxLeft+<nCol>+if(at('~',<cPrompt>) > 0,len(<cPrompt>)-1,len(<cPrompt>))+1,{|val| if(pcount() > 0, <nVar> := val, <nVar>) } , 'TEXTFIELD', _GetPict(<nLen>,<nPlace>) ) ) ;;
atail(getlist):cargo := { nBoxTop+<nRow>                       ,;
                          nBoxLeft+<nCol>                      ,;
                          nBoxTop+<nRow>                       ,;
                          nBoxLeft+<nCol>+if(at('~',<cPrompt>) > 0,len(<cPrompt>)-1,len(<cPrompt>))+<nLen>,;
                          <cPrompt>                            ,;
                          nil                                  ,;
                          'TEXTFIELD'                          ,;
                          <bHelp>                              ,;
                          <cColor>                             ,;
                          {<nHotKey>}                          ,;
                          NIL                                  ,;
                          NIL                                  ,;
                          NIL                                  ,;
                          NIL                                  ,;
                          nil                                  ,;
                          NIL                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil}                                 ;;
SetGetValid(aTail(GetList),[<bValid>],[<bWhenBlock>])                         ;;
GetDisplay(aTail(Getlist))

#xTranslate @ <nRow>,<nCol> Get <cVar> As Spinner   [<oName>]   ;
                            Prompt <cPrompt>                    ;
                            [ Color <cColor>  ]                 ;
                            [ Count  <bBlock> ]                 ;
                            [ Hotkey <nHotKey,...>]             ;
                            [ Picture <cPict> ]                 ;
                            [ When <bWhenBlock>]                ;
                            [ Valid <bValid>  ]                 ;
			    [ Help <bHelp>    ]                 ;
=>                                                              ;
AAdd( GetList, [<oName> := ] GetNew(nBoxTop+<nRow>,nBoxLeft+<nCol>+if(at('~',<cPrompt>) > 0,len(<cPrompt>)-1,len(<cPrompt>))+1,{|val| if(pcount() > 0, <cVar> := val, <cVar>) } , 'SPINNER', [<cPict>]) ) ;;
atail(getlist):cargo := { nBoxTop+<nRow>                       ,;
                          nBoxLeft+<nCol>                      ,;
                          nBoxTop+<nRow>                       ,;
                          nBoxLeft+<nCol>+if(at('~',<cPrompt>) > 0,len(<cPrompt>)-1,len(<cPrompt>))+len(<cVar>)+7,;
                          <cPrompt>                            ,;
                          <bBlock>                             ,;
                          'SPINNER'                            ,;
                          <bHelp>                              ,;
                          <cColor>                             ,;
                          {<nHotKey>}                          ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          NIL                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil }                                ;;
SetGetValid(aTail(getlist), [<bValid>], [<bWhenBlock>])        ;;
GetDisplay(aTail(Getlist))

#xTranslate @ <nRow>,<nCol> Get <cVar> As DropDown  [<oName>]   ;
                            Prompt <cPrompt>                    ;
                            Array  <aArray>                     ;
                            DropDown Width  <nLength>           ;
                            DropDown Height <nHeight>           ;
                            [ HotKey <nHotKey,...> ]            ;
                            [ Color <cColor>   ]                ;
                            [ Picture <cPict>  ]                ;
                            [ Valid <bValid>   ]                ;
                            [ When <bWhenBlock>]                ;
                            [ Action <bAction> ]                ;
                            [ Help <bHelp> ]                    ;
=>                                                              ;
AAdd( GetList, [<oName> := ] GetNew(nBoxTop+<nRow>,nBoxLeft+<nCol>+if(at("~",<cPrompt>) > 0,len(<cPrompt>)-1,len(<cPrompt>))+1,{|val| if(pcount() > 0, <cVar> := val, <cVar>) } , 'DROPDOWN', [<cPict>]) ) ;;
atail(getlist):cargo := { nBoxTop+<nRow>                       ,;
                          nBoxLeft+<nCol>                      ,;
                          nBoxTop+<nRow>                       ,;
                          nBoxLeft+<nCol>+if(at('~',<cPrompt>) > 0,len(<cPrompt>)-1,len(<cPrompt>))+len(<cVar>)+4,;
                          <cPrompt>                            ,;
                          nil                                  ,;
                          'DROPDOWN'                           ,;
                          <bHelp>                              ,;
                          <cColor>                             ,;
                          {<nHotKey>}                          ,;
                          nil                                  ,;
                          nil                                  ,;
                          <bAction>                            ,;
                          ""                                   ,;
                          <aArray>                             ,;
                          { nBoxTop+<nRow>+1, nBoxLeft+<nCol>+len(<cPrompt>)+if(at("~",<cPrompt>) > 0,-1,0)+len(<cVar>)+2, nBoxTop+<nRow>+1+<nHeight>+1,nBoxLeft+<nCol>+if(at('~',<cPrompt>) > 0,len(<cPrompt>)-1,len(<cPrompt>))+len(<cVar>)+2+<nLength>+2 },;
                          nil                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil }     ;;
SetGetValid(aTail(getlist), [<bValid>], [<bWhenBlock>])        ;;
GetDisplay(aTail(Getlist))

#xTranslate @ <nRow>,<nCol> Get <nVar> As RadioButton [<oName>] ;
                            Array  <aArray>                     ;
                            [ Prompt <cPrompt>  ]               ;
                            [ Initial <nButton> ]               ;
                            [ Color <cColor>    ]               ;
                            [ Hotkey <nHotKey,...>  ]           ;
                            [ When <bWhenBlock> ]               ;
                            [ Action <bAction> ]                ;
                            [ Help <bHelp> ]                    ;
=>                                                              ;
AAdd( GetList, [<oName> := ] GetNew(nBoxTop+<nRow>,nBoxLeft+<nCol>,{|| ''} , "RADIOBUTTON")) ;;
aTail(getlist):cargo := { nBoxTop+<nRow>                       ,;
                          nBoxLeft+<nCol>                      ,;
                          nBoxTop+<nRow>+len(<aArray>)+1,nBoxLeft+<nCol>+len( aTail(<aArray>) )+5,;
                          [<cPrompt>]                          ,;
                          nil                                  ,;
                          "RADIOBUTTON"                        ,;
                          <bHelp>                              ,;
                          <cColor>                             ,;
                          {<nHotKey>}                          ,;
                          nil                                  ,;
                          nil                                  ,;
                          <aArray>                             ,;
                          if(<nVar> == nil .or. <nVar> <= 0, <nVar> := 1, <nVar>),;
                          <bAction>                            ,;
                          NIL                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil }                                ;;
_SetUpRadioButtons(aTail(getlist) )                            ;;
SetGetValid(aTail(getlist), nil, [<bWhenBlock>])               ;;
aTail(getlist):postblock := {|oGet| <nVar> := getradiovalue(oGet,<nVar>), .t. }      ;;
GetDisplay(aTail(Getlist))

#xTransLate @ <nRow>,<nCol> Get <lVar> As Checkbox [<oName>]    ;
                            Prompt <cPrompt>                    ;
                            [ Initial <lInit> ]                 ;
                            [ Color <cColor>  ]                 ;
                            [ Hotkey <nHotKey,...>]             ;
                            [ When <bWhenBlock> ]               ;
			    [ Help <bHelp> ]                    ;
=>                                                              ;
AAdd( GetList, [<oName> := ] GetNew(nBoxTop+<nRow>,nBoxLeft+<nCol>,{|| ''} , "CHECKBOX") ) ;;
aTail(getlist):cargo := { nBoxTop+<nRow>                       ,;
                          nBoxLeft+<nCol>                      ,;
                          nBoxTop+<nRow>                       ,;
                          nBoxLeft+<nCol>+if(at('~',<cPrompt>) > 0,len(<cPrompt>)-1,len(<cPrompt>))+2,;
                          <cPrompt>                            ,;
                          nil                                  ,;
                          "CHECKBOX"                           ,;
                          <bHelp>                              ,;
                          <cColor>                             ,;
                          {<nHotKey>}                          ,;
                          nil                                  ,;
                          nil                                  ,;
                          <lVar>                               ,;
                          nil                                  ,;
                          nil                                  ,;
                          NIL                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil                                  ,;
                          nil } ;;
aTail(getlist):postblock := {|oGet| <lVar> := getcheckboxvalue(oGet,<lVar>), .t. }   ;;
SetGetValid(aTail(getlist), nil, [<bWhenBlock>])               ;;
GetDisplay(aTail(Getlist))

#xTransLate Kill System Event    ;
=>                               ;
lSystemEvent   := .f.           ;;
bSystemEvent   := nil           ;;
nSystemSeconds := nil           ;;
nEverySeconds  := nil

#xTranslate Kill DialogBox       ;
=>                               ;
RemoveDialog(aSaveScreen,aBoxes)

#xTranslate Kill DeskTop         ;
=>                               ;
RemoveDialog(aSaveScreen,aBoxes);;
Set ScoreBoard On

#xTranslate Init Controls        ;
=>                               ;
Public aSaveScreen              ;;
Public aBoxes                   ;;
Public aSysColors               ;;
Public bSystemEvent             ;;
Public nEverySeconds            ;;
Public nSystemSeconds           ;;
Public lSystemEvent             ;;
Public nBoxTop                  ;;
Public nBoxLeft                 ;;
Public nBoxBot                  ;;
Public nBoxRight                ;;
Public cBoxHeader               ;;
setcolor("W/N,W+/N,N/N,N/N,N/W") ;;
aSysColors     := { 'N/W','W+/W','N/W','W+/W','W+/W','N/W','GR+/W','N/W','W/N','N/W','N/W*',"N/W*","W+/N" }    ;;
aSaveScreen := {}               ;;
aBoxes      := {}               ;;
lSystemEvent := .f.             ;;
l_Controls_Sys := .t.           ;;
setblink(.f.)                   ;;
Set Key K_F1 To      ;;
Set Scoreboard off

#xTranslate Init Mouse           ;
=>                               ;
Public lMouse                   ;;
lMouse := ismouse()

#xTransLate Do System Event <bBlock>    ;
               Every <nSeconds> Seconds ;
=>                                      ;
lSystemEvent   := .t.                  ;;
nSystemSeconds := Seconds()            ;;
nEverySeconds  := <nSeconds>           ;;
bSystemEvent   := <bBlock>

#xTransLate @ <nRow>,<nCol> Say Text  <cText>  ;
                            [ Color <cColor> ] ;
                            [ Picture <cPic> ] ;
=>                                             ;
SayText(nBoxTop+<nRow>, nBoxLeft+<nCol>, <cText>, <cColor>, <cPic>)


#xTranslate Create Menu <oMenu>                ;
            [ HotKey <nHotKey,...> ]           ;
            [ Help <bHelp> ]                   ;
            [ Menu Color <cColor> ]            ;
            [ Disable Color <cColor2> ]        ;
=>                                             ;
AAdd( GetList, <oMenu> := GetNew(nBoxTop+1,nBoxLeft+1,{|| ''}, "MENU") ) ;;
GetDisplay(aTail(Getlist))                              ;;
<oMenu>:cargo := { nBoxTop+1                  ,;
                   nBoxLeft                   ,;
                   nBoxTop+1                  ,;
                   nBoxRight+1                ,;
                   nil                        ,;
                   nil                        ,;
                   "MENU"                     ,;
                   <bHelp>                    ,;
                   SetMenuColor(<cColor>,<cColor2>),;
                   {<nHotKey>}                ,;
                   nil                        ,;
                   nil                        ,;
                   nil                        ,;
                   nil                        ,;
                   nil                        ,;
                   nil                        ,;
                   nil                        ,;
                   nil                        ,;
                   nil                        ,;
                   nil                         }

#xTranslate @ Column <nCol> Create Menu Option <cOption> Using <aItems>  ;
[ ACTION <bActionBlock> ]                                                ;
=>                                                                       ;
aadd(<aItems>, { <cOption>, nBoxTop+1, nBoxLeft+<nCol>, {}, [<bActionBlock>] }  )

#xTranslate Create Separator Attach to <aItems> ;
=>                                              ;
SetUpMenu( aTail(<aItems>), '', {|oGet| oGet:exitstate := GE_NOEXIT }, .t., .F., .f.)

#xTranslate Create Item <cItem> Attach to <aItems> ;
[ Action <bActionBlock> ]                          ;
[ <lVar1: SEPARATOR>    ]                          ;
[ When <bWhen>          ]                          ;
=>                                                 ;
SetUpMenu( aTail(<aItems>), <cItem>, if(!<.lVar1.>,<bActionBlock>,{|oGet| oGet:exitstate := GE_NOEXIT }), <.lVar1.>, .F., .F., <bWhen>, .f.  )


#xTranslate Create Sub Item <cItem> Attach to <aItems> ;
[ Action <bActionBlock> ]                          ;
[ <lVar1: SEPARATOR>    ]                          ;
[ When <bWhen>          ]                          ;
[ Sub Items <aSubItems> ]                          ;
=>                                                 ;
SetUpMenu( aTail(<aItems>), <cItem>, if(!<.lVar1.>,<bActionBlock>,{|oGet| oGet:exitstate := GE_NOEXIT }), <.lVar1.>, .F., .F., <bWhen>, .t., <aSubItems> )


#xTransLate Attach <aItems> to <oMenu>  ;
=>                                      ;
<oMenu>:cargo\[14\] := <aItems>        ;;
asize(<oMenu>:cargo, 20)               ;;
SizeMenu(<aItems>)                     ;;
DrawMenu(<oMenu>)

//-------------------------
//   INI FILE TRANSLATES
//-------------------------

// INI FILE STRUCTURE
//===================================================
//                     <cFile>
//
//  [<SECTION>]
//  <cVar>=<cVal>
//  <cVar>=<cVal>
//  <cVar>=<cVal>
//
//  [<SECTION>]
//  <cVar>=<cVal>
//
//===================================================

//-------------------------------------------
//  Load all Ini Information into an array,
//  great to use for a t-browse...
//-------------------------------------------
#xtranslate LOAD INI                           ;
            USING <aIniArray>                  ;
            FILE <cFile>                       ;
=>                                             ;
    <aIniArray> := Load_All_Ini( <cFile> )

//-------------------------------------------------
//  Saves all Ini information to the file <cFile>
//-------------------------------------------------
#xtranslate SAVE INI                           ;
            USING <aIniArray>                  ;
            FILE <cFile>                       ;
=>                                             ;
    Save_All_Ini( <cFile>, <aIniArray> )

//--------------------------------------------------------------
//  Get the value of <cVal> from the variable <cVar> under the
//  section <cSection> in the file <cFile>
//--------------------------------------------------------------
#xtranslate GET <cVal> FROM <cVar>             ;
            SECTION <cSection>                 ;
            FILE <cFile>                       ;
            [ INITIAL <cInit> ]                ;
            [ ARRAY <aArray> ]                 ;
=>                                             ;
    <cVal> := Get_cVal( <cVar>, <cSection>, <cFile>, [<aArray>], [<cInit>] )

//-----------------------------------------------------------------
//  Save's the value of <cVal> into the variable <cVar> under the
//  section <cSection> in the file <cFile>
//-----------------------------------------------------------------
#xtranslate SAVE <cVal> INTO <cVar>            ;
            SECTION <cSection>                 ;
            FILE <cFile>                       ;
            [ ARRAY <aArray> ]                 ;
=>                                             ;
     Save_cVal(<cVal>, <cVar>, <cSection>, <cFile>, [<aArray>] )

//-----------------------------------------------------------------
//  Remove the variable cVar and the value under section cSection
//-----------------------------------------------------------------
#xtranslate DELETE <cVar>                      ;
            SECTION <cSection>                 ;
            FILE <cFile>                       ;
=>                                             ;
     Del_cVar(<cVar>, <cSection>, <cFile> )

//-----------------------------------------------------------------
//  Remove the variables and section under the section <cSection>
//-----------------------------------------------------------------
#xtranslate DELETE SECTION <cSection>          ;
            FILE <cFile>                       ;
=>                                             ;
     Del_cVar("", <cSection>, <cFile>, .t. )

//---------------------------------------------
//  An easy way to null out the variable cVar
//---------------------------------------------
#xtranslate CLEAR <cVar>                       ;
            SECTION <cSection>                 ;
            FILE <cFile>                       ;
=>                                             ;
     Save_cVal("", <cVar>, <cSection>, <cFile> )

#xtranslate Get Section <cSection>             ;
            into <aArray>                      ;
            File <cFile>                       ;
=>                                             ;
<aArray> := get_cval("", <cSection>, <cFile>, nil, nil, .t. )
