//=============================================================================
//
//  File name - menudemo.prg
//  Created   - RTD  04/30/94  08:19 am
//
//  Copyright (c) 1994  Raymond T. Deal
//
//  Functions:
//
//=============================================================================

#include 'controls.ch'

#define H_MENU    "00010"
#define H_ABOUT   "00020"
#define H_BROWSE  "00030"
#define H_ADD     "00040"
#define H_EDIT    "00050"
#define H_CHANGE  "00060"
#define H_CLOSE   "00070"
#define H_NAME    "00080"
#define H_ADDRESS "00090"
#define H_PHONE   "00100"
#define H_OK      "00110"
#define H_CLIENTDATA "00120"
#define H_NOHELP  ""
#define H_NOTDONE "00130"

Static cClientName := ''
Static nRecord     := 0
static aStatus     := {"-","\","|","/"}
static nStatus     := 1
Static nStrokes    := 1

Static aAbout     := { 'Totally Clipper Controls '        ,;
                       'By'                               ,;
                       'Raymond T. Deal'                  ,;
                       '661 nw 37th Street'               ,;
                       'Pompano Beach, Fl. 33064'         ,;
                       ''                                 ,;
                       'Register By Calling:'             ,;
                       'Home   -   (305)783-2332'         ,;
                       'Office -   (305)783-0875'          }

//=============================================================================
// Function    - Main
// Description - The main part of the program, this creates many type of gets
// See also    -
// Created     - RTD  05/09/94  02:39 pm
// Revised     - RTD  05/09/94  02:39 pm
//
// Format      - Main()
//
// Parameters  - None.
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Examples    -
//
// Changes/Fixes:
//
//=============================================================================
Function Main()
Local GetList    := {}
Local aMenu      := {}
Local oMenu      := nil
Local nRecNo     := 0
Local cFile      := "Test"
Local aSubItems  := { {"Sub Menu Item 1", {|nExitState| Help(H_NOTDONE),nExitState := GE_NOEXIT }} ,;
                      {"Sub Menu Item 2", {|nExitState| Help(H_NOTDONE),nExitState := GE_NOEXIT }} ,;
                      {"Sub Menu Item 3", {|nExitState| Help(H_NOTDONE),nExitState := GE_NOEXIT },nil,{|| .f. }}  ;
                    }

   //setcancel(.f.)
   set intensity on
   cls

   //-------------------------------------
   //  Initialize the controls and mouse
   //-------------------------------------
   Init Controls
   Init Mouse

   //------------------------
   // Create a System Event
   //------------------------
   Do System Event {|oGet| ShowActive(oGet) } Every .25 Seconds

   //--------------------------
   //  Make a DialogBox 18x70
   //--------------------------
   @ 0,0 Get as DialogBox                   ;
	 Header 'CLIPPER CONTROLS'               ;
	 Height 25                               ;
	 Length 80                               ;
    Fill Character ""                      ;
    Maximize

    //Color 'N+/B*'                           ;


   //-----------------------
   //  Create a Menu Object
   //-----------------------
   Create Menu oMenu        ;
     HotKey K_ESC           ;
     Help {|| help(H_MENU)  }

     //Menu Color "N/BG"     ;
     //Disable Color "W/BG"  ;

   //------------------------
   //  Create a Menu Option
   //------------------------
   @ Column 1  Create Menu Option 'Client' Using aMenu

   //--------------------------------------
   //  Create Menu Items for 'File' Option
   //--------------------------------------
   Create Item 'Edit...' Attach to aMenu       ;
	  Action {|oGet| nRecNo := selectclient(),  ;
		   if (nRecNo > 0, edit(.f.,nRecno),;
		   nil), oGet:exitstate := GE_NOEXIT}
   Create Item 'Add...' Attach to aMenu        ;
	  Action {|oGet| edit(.t.), oGet:exitstate := GE_NOEXIT }
   Create Separator Attach to aMenu
   Create Item 'About...' Attach to aMenu        ;
	  Action {|oGet| help(H_ABOUT), oGet:exitstate := GE_NOEXIT }
   Create Separator Attach to aMenu
   Create Item 'DOS Shell' Attach to aMenu        ;
	  Action {|oGet| swaptodos(), oGet:exitstate := GE_NOEXIT }
   Create Separator Attach to aMenu
   Create Item 'Cancel  <Esc> ' Attach to aMenu        ;
	  Action {|oGet| oGet:exitstate := GE_LEAVESUBMENU }

   @ Column 10 Create Menu Option 'Controls' Using aMenu

   //------------------------------------------
   //  Create Menu Items for 'Controls' Option
   //------------------------------------------
   Create Item 'Push Button...' Attach to aMenu     ;
	  Action {|oGet| Controls(1), oGet:exitstate := GE_NOEXIT }
   Create Item 'Spinner Button...  ' Attach to aMenu     ;
     Action {|nExitState| Controls(2), nExitState := GE_NOEXIT }
   Create Item 'DropDown Button... ' Attach to aMenu     ;
     Action {|nExitState| Controls(3), nExitState := GE_NOEXIT }
   Create Item 'Radio Button...    ' Attach to aMenu     ;
     Action {|nExitState| Controls(4), nExitState := GE_NOEXIT }
   Create Item 'TextField...' Attach to aMenu     ;
	  Action {|oGet| Controls(5), oGet:exitstate := GE_NOEXIT }
   Create Item 'BrowseBox...       ' Attach to aMenu     ;
     Action {|oGet| Controls(6), oGet:exitstate := GE_NOEXIT }
   Create Item 'CheckBox...        ' Attach to aMenu     ;
	  Action {|oGet| Controls(7), oGet:exitstate := GE_NOEXIT }
   Create Separator Attach to aMenu
   Create Item 'Menus...           ' Attach to aMenu     ;
	  Action {|oGet| Controls(8), oGet:exitstate := GE_NOEXIT }

   // Create a menu item with sub items, and make
   // one of the sub items disabled
   Create Item 'Sub Menus...' Attach to aMenu
     Create Sub Item 'Sub Menu Item One' Attach to aMenu             ;
       Action {|nExitState| Help(H_NOTDONE),nExitState := GE_NOEXIT }
     Create Sub Item 'Disabled Item Two' Attach to aMenu             ;
       Action {|nExitState| Help(H_NOTDONE),nExitState := GE_NOEXIT };
       When {|| .f.  }
     Create Sub Item 'Sub Menu Item Three ' Attach to aMenu          ;
       Sub Items aSubItems

   // Create a Disabled Menu Item
   Create Item 'Disabled Menu Item ' Attach to aMenu    ;
     Action {|oGet| oGet:exitstate := GE_NOEXIT }       ;
     When {|| .f.  }

   Create Separator Attach to aMenu
   Create Item 'Cancel       <Esc> ' Attach to aMenu    ;
	  Action {|oGet| oGet:exitstate := GE_LEAVESUBMENU }

   @ Column 21 Create Menu Option 'Other' Using aMenu
   Create Item 'Calculator()  ' Attach to aMenu     ;
     Action {|oGet| Calculator(3,45,nil), oGet:exitstate := GE_NOEXIT }
   Create Item 'FileManager() ' Attach to aMenu     ;
     Action {|oGet| cFile := FileManager()         ,;
                    if(!empty(cFile)               ,;
                    msg_box(nil,nil,{"You Have Selected",;
                                     cFile},"FILE SELECTED",;
                                     NIL,"W+/B"),) ,;
                    oGet:exitstate := GE_NOEXIT }
   Create Item 'Msg_Box()     ' Attach to aMenu     ;
	  Action {|oGet| Msg_Box(nil,nil,{"Is the Message Box Handy?"},,B_YES+B_NO), oGet:exitstate := GE_NOEXIT }
   Create Item 'Pop_Menu()    ' Attach to aMenu     ;
     Action {|oGet| Pop_Menu(nil,nil,{  {" Option One "    ,{|nExitState| Msg_Box(nil,nil,{"This is Option One."}),nExitState := GE_NOEXIT}}     ,;
					  {" Option Two "    ,{|nExitState| Msg_Box(nil,nil,{"This is Option Two."}),nExitState := GE_NOEXIT}}     ,;
					  {" Option Three "  ,{|nExitState| Msg_Box(nil,nil,{"This is Option Three."}),nExitState := GE_NOEXIT}}     ,;
					  {" Cancel "        ,{|nExitState| nExitState := GE_ESCAPE}}})   ,;
                       oGet:exitstate := GE_NOEXIT }
   Create Item 'FileViewer()  ' Attach to aMenu     ;
	  Action {|oGet| ShowText(), oGet:exitstate := GE_NOEXIT }

   Create Item 'Status Bars' Attach to aMenu

     Create Sub Item 'HorizontalBar()' Attach to aMenu              ;
       Action {|nExitState| Bar(1), nExitState := GE_NOEXIT }
     Create Sub Item 'VerticalBar()' Attach to aMenu                ;
       Action {|nExitState| Bar(2), nExitState := GE_NOEXIT }
     Create Sub Item 'StatusBar()' Attach to aMenu                  ;
       Action {|nExitState| Bar(3),nExitState := GE_NOEXIT }
     Create Sub Item 'All Bars' Attach to aMenu                     ;
       Action {|nExitState| Bar(0),nExitState := GE_NOEXIT }


   Create Separator Attach to aMenu
   Create Item 'Cancel        ' Attach to aMenu     ;
	  Action {|oGet| oGet:exitstate := GE_LEAVESUBMENU }

   //------------------------
   //  Create a Menu Option
   //------------------------
   @ Column 29 Create Menu Option 'Help' Using aMenu

   //--------------------------------------
   //  Create Menu Items for 'Help' Option
   //--------------------------------------
   Create Item 'Help        ' Attach to aMenu     ;
	  Action {|oGet| Help(H_NOHELP), oGet:exitstate := GE_NOEXIT }
   Create Separator Attach to aMenu
   Create Item 'Cancel      ' Attach to aMenu     ;
	  Action {|oGet| oGet:exitstate := GE_LEAVESUBMENU }

   //------------------------
   //  Create a Menu Option
   //------------------------
   @ Column 75 Create Menu Option 'Exit' Using aMenu ;
     Action {|oGet| if(Msg_Box(nil,nil, { "Are You Sure You want to Exit?"}, nil, ;
             B_YES+B_NO), oGet:exitstate := GE_ESCAPE, oGet:exitstate := GE_NOEXIT) }


   //----------------------------------------
   //  Attach all Menu Items and Options to
   //  the Menu Object
   //----------------------------------------
   Attach aMenu to oMenu

   read

   //---------------------
   //  Kill System Event
   //---------------------
   Kill System Event

   //-------------------------
   //  Remove the Dialog Box
   //-------------------------
   kill dialogbox


Return nil

//=============================================================================
// Function    - Edit
// Description - Edit's the selected person from the tbrowse
// See also    -
// Created     - RTD  09/05/94  11:06:10
// Revised     - RTD  09/05/94  11:06:10
//
// Format      - Edit()
//
// Parameters  - None.
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Changes/Fixes:
//
//=============================================================================
Function Edit(lAdd,nRecNo)
Local GetList    := {}
Local cName      := ''
Local cAddress   := ''
Local cPhone     := ''
Local cAge       := ''
Local cDate      := ''
Local oButton    := nil
Local oPhone     := nil
Local oName      := nil
Local oAddress   := nil
Local lReturn    := .f.
Local cHeader    := if(lAdd,'ADDING A PERSON','EDITING A PERSON')
Local bCount1    := {|oGet,nDays,cVal| cVal := dtoc( (ctod(cDate)+nDays) )    }
Local bCount2    := {|oGet,nAge,cVal|  cVal := padl(alltrim(str(val(cAge)+nAge)),2,'0') }
Local aComputer  := {'8086 Computer','8088 Computer','286  Computer','386  Computer','486  Computer'}
Local aRadio     := {' 16 MHZ ',' 25 MHZ ',' 33 MHZ ',' 40 MHZ ',' 50 MHZ ',' 66 MHZ '}
Local oCpuType   := nil
Local oRadButton := nil
Local cComputer  := space(13)
Local nButton    := 0
Local lVar       := .f.
Local oCheckBox  := nil
Local oMenu      := nil
Local aMenu      := {}

   //-------------------------
   //  Use the test database
   //-------------------------
   use test.dbf alias test new index test.ntx
   if(!lAdd, test->(dbgoto(nRecNo)),)

   cName     := if(lAdd,space(Len(test->(eval(fieldblock('Name'    ))))),test->Name)
   cAddress  := if(lAdd,space(Len(test->(eval(fieldblock('Address' ))))),test->address)
   cPhone    := if(lAdd,space(Len(test->(eval(fieldblock('Phone'   ))))),test->phone)
   cAge      := if(lAdd,space(Len(test->(eval(fieldblock('Age'     ))))),test->age)
   cDate     := if(lAdd,space(Len(test->(eval(fieldblock('Date'    ))))),test->date)
   cComputer := if(lAdd,space(Len(test->(eval(fieldblock('Computer'))))),test->computer)
   nButton   := if(lAdd, 0, test->ncomputer)
   lVar      := if(lAdd,.f.,test->lVar)

   @ 3,8 Get as DialogBox  ;
	 Header cHeader    ;
	 Height 17         ;
    Length 64
    //Color 'W/B'

   //-----------------------
   //  Create a Menu Object
   //-----------------------
   Create Menu oMenu       ;
	  Hotkey K_ESC     ;
	  Help {|| help(H_MENU) }

   //------------------------
   //  Create a Menu Option
   //------------------------
   @ Column 1  Create Menu Option 'Main' Using aMenu

   //--------------------------------------
   //  Create Menu Items for 'File' Option
   //--------------------------------------
   Create Item 'File    ' Attach to aMenu        ;
     Action {|oGet| oGet:exitstate := GE_NOEXIT }
   Create Sub Item 'Open    ' Attach to aMenu        ;
     Action {|nExitState| Help(H_NOTDONE), nExitstate := GE_NOEXIT }
   Create Sub Item 'Close   ' Attach to aMenu        ;
     Action {|nExitState| Help(H_NOTDONE), nExitState := GE_NOEXIT }

   Create Separator Attach to aMenu
   Create Item 'About   ' Attach to aMenu        ;
	  Action {|oGet| help(H_ABOUT), oGet:exitstate := GE_NOEXIT }
   Create Separator Attach to aMenu
   Create Item 'Cancel  ' Attach to aMenu        ;
	  Action {|oGet| oGet:exitstate := GE_LEAVESUBMENU }

   //------------------------
   //  Create a Menu Option
   //------------------------
   @ Column 10 Create Menu Option 'Help' Using aMenu

   //--------------------------------------
   //  Create Menu Items for 'Help' Option
   //--------------------------------------
   Create Item 'Help        ' Attach to aMenu     ;
	  Action {|oGet| Help(H_NOHELP), oGet:exitstate := GE_NOEXIT }
   Create Separator Attach to aMenu
   Create Item 'Cancel      ' Attach to aMenu     ;
	  Action {|oGet| oGet:exitstate := GE_LEAVESUBMENU }

   //------------------------
   //  Create a Menu Option
   //------------------------
   @ Column 59 Create Menu Option 'Exit' Using aMenu  ;
	  Action {|oGet| oGet:exitstate := GE_ESCAPE }


   //----------------------------------------
   //  Attach all Menu Items and Options to
   //  the Menu Object
   //----------------------------------------
   Attach aMenu to oMenu

   @ 3,2  Get cName As TextField oName           ;
		      Prompt "~Enter Name....:"  ;
		      Picture '@K'               ;
            HotKey K_ALT_E             ;
		      Help {|| help(H_NAME) }    ;
		      Valid {|| if(empty(cName), ;
			    (msg_box(nil,nil,    ;
		       {"Name Cannot Be Blank!"},;
			    "ERROR",NIL,"W/R")  ,;
			      .f.) , .t.)  }

   @ 4,2  Get cAddress As TextField oAddress     ;
		      Prompt "E~nter Address.:"  ;
		      Picture '@K'               ;
		      Help {|| help(H_ADDRESS) } ;
		      HotKey K_ALT_N

   @ 5,2  Get cPhone As TextField oPhone         ;
		      Prompt "Ente~r Phone No:"  ;
		      Picture "(999)999-9999"    ;
            Help {|| help(H_PHONE) }   ;
		      HotKey K_ALT_R

   @ 7,2 Get cDate As Spinner                    ;
		      Prompt 'D~ate..........:'  ;
		      Count  bCount1             ;
		      Picture '@D'               ;
            Help {|| help(H_NOHELP) }  ;
		      HotKey K_ALT_A

   @ 8,2 Get cAge  As Spinner                    ;
		      Prompt 'A~ge...........:'  ;
		      Count  bCount2             ;
		      Picture '99'               ;
		      Valid {|| cAge != '00'  }  ;
            Help {|| help(H_NOHELP) }  ;
		      HotKey K_ALT_G

   //-------------------------------------------
   //  Create DropDown box for different types
   //  of Computers...
   //-------------------------------------------
   @ 10,2 Get cComputer As DropDown oCPUType     ;
		      Prompt 'Com~puter Type.:'  ;
		      Array aComputer            ;
		      DropDown Width 14          ;
		      DropDown Height 3          ;
		      HotKey K_ALT_P             ;
		      valid {||  ascan(aComputer,cComputer) > 0 } ;
            help {|| help(H_NOHELP) }


   @ 12,2  Get lVar As Checkbox oCheckBox        ;
		      Prompt ' Check This ~Box!' ;
            help {|| help(H_NOHELP) }  ;
		      Hotkey K_ALT_B

   //-------------------------------------------
   //  Create Radio Buttons with that names of
   //  computer types...
   //-------------------------------------------
   @ 3,48 Get nButton As RadioButton oRadButton  ;
	 Array  aRadio                           ;
	 Prompt 'CPU ~Speed:'                    ;
    help {|| help(H_NOHELP) }               ;
	 HotKey K_ALT_S

   @ 14,2 get as pushbutton oButton         ;
	 Prompt "~Ok"                            ;
    Hotkey K_ALT_O,K_ENTER                 ;
	 ValidateAll                             ;
	 help {|| help(H_NOHELP) }               ;
	 Action {|oGet| lReturn := .t., SaveInfo(getlist,lAdd, nButton,lVar),;
			oGet:exitstate := GE_ESCAPE }

   @ 14,9 get as pushbutton oButton         ;
	 Prompt "C~lose"                         ;
    HotKey K_ALT_L,K_ESC                    ;
	 SuppressValid                           ;
	 help {|| help(H_NOHELP) }               ;
	 Action {|oGet| oGet:exitstate := GE_ESCAPE }

   @ 14,19 get as pushbutton oButton        ;
    Prompt "Try Ne~w Colors"                ;
    HotKey K_ALT_W                          ;
    help {|| help(H_NOHELP) }               ;
	 Action {|oGet| ChangeView(getlist),oGet:exitstate := GE_NOEXIT }

   @ 14,54 get as pushbutton oButton        ;
	 Prompt "~Help"                          ;
    Hotkey K_ALT_H                          ;
	 Action {|oGet| Help(H_CLIENTDATA),oGet:exitstate := GE_NOEXIT }


   Read

   //------------------------
   //  Remove the DialogBox
   //------------------------
   kill dialogbox
   test->(dbclosearea())

Return lReturn

//=============================================================================
// Function    - SaveInfo
// Description - Saves all of the info from the gets into the database file
// See also    -
// Created     - RTD  09/05/94  11:06:58
// Revised     - RTD  09/05/94  11:06:58
//
// Format      - SaveInfo( getlist )
//
// Parameters  - getlist :
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Changes/Fixes:
//
//=============================================================================
Function SaveInfo(getlist,lAdd,nButton,lVar)

   if lAdd
      Test->(dbappend())
   endif

   Test->(rlock())
   Test->name      := getlist[2]:varget()
   Test->address   := getlist[3]:varget()
   Test->phone     := getlist[4]:varget()
   Test->date      := getlist[5]:varget()
   Test->age       := getlist[6]:varget()
   Test->Computer  := getlist[7]:varget()
   Test->nComputer := nButton
   Test->lVar      := lVar
   Test->(dbunlock())

return nil

//=============================================================================
// Function    - UpdateBrow
// Description -
// See also    -
// Created     - RTD  12/05/94  12:35:15
// Revised     - RTD  12/05/94  12:35:15
//
// Format      - UpdateBrow( oBrowse, lAll )
//
// Parameters  - oBrowse :
//               lAll    :
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Changes/Fixes:
//
//=============================================================================
Function UpdateBrow(oBrowse,lAll)

    MouseOff()
    //----------------------
    //  Update the tbrowse
    //----------------------
    if lAll
       oBrowse:refreshall()
    else
       oBrowse:refreshcurrent()
    endif
    oBrowse:forcestable()
    MouseOn()

Return nil

//=============================================================================
// Function    - SwapToDos
// Description -
// See also    -
// Created     - RTD  06/17/94  02:16 pm
// Revised     - RTD  06/17/94  02:16 pm
//
// Format      - SwapToDos()
//
// Parameters  - None.
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Examples    -
//
// Changes/Fixes:
//
//=============================================================================
Function SwapToDos()
Local cScreen := ''

  MouseOff()
  cScreen := savescreen(0,0,maxrow(),maxcol())
  set cursor on
  cls
  Run Command
  Restscreen(0,0,maxrow(),maxcol(),cScreen)
  set cursor off
  MouseOn()

Return nil

//=============================================================================
// Function    - UpdateText
// Description -
// See also    -
// Created     - RTD  06/08/94  04:01 pm
// Revised     - RTD  06/08/94  04:01 pm
//
// Format      - UpdateText()
//
// Parameters  - None.
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Examples    -
//
// Changes/Fixes:
//
//=============================================================================
Function UpdateText()
Local cName    := Test->name
Local cAddress := Test->Address
Local cPhone   := Test->Phone

   @ 5,43 Say Text 'Name:' color 'GR+/W'
   @ 6,43 Say Text cName
   @ 7,43 Say Text 'Address:'  color 'GR+/W'
   @ 8,43 Say Text cAddress
   @ 9,43 Say Text 'Phone:' color 'GR+/W'
   @ 10,43 Say Text cPhone

Return nil

//=============================================================================
// Function    - ShowActive
// Description -
// See also    -
// Created     - RTD  06/09/94  04:07 pm
// Revised     - RTD  06/09/94  04:07 pm
//
// Format      - ShowActive()
//
// Parameters  - None.
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Examples    -
//
// Changes/Fixes:
//
//=============================================================================
Function ShowActive(oGet)
   Local nChr := 0

	Mouseoff()
    @ nBoxTop,nBoxRight Say aStatus[nStatus] color "N/W*"
	if nStatus == len(aStatus)
		nStatus := 0
	endif
	nStatus++
	MouseOn()


return nil

//=============================================================================
// Function    - Controls
// Description -
// See also    -
// Created     - RTD  07/06/94  10:52 am
// Revised     - RTD  07/06/94  10:52 am
//
// Format      - Controls( nType )
//
// Parameters  - nType :
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Examples    -
//
// Changes/Fixes:
//
//=============================================================================
Function Controls(nType)
Local Getlist    := {}
Local oButton    := nil
Local oCPUType   := nil
Local aComputer  := {'8086 Computer','8088 Computer','286  Computer','386  Computer','486  Computer'}
Local cComputer  := space(13)
Local bCount1    := {|oGet,nDays,cVal| cVal := dtoc( (ctod(cDate)+nDays) )    }
Local cDate      := dtoc(Date())
Local aRadio     := {' 16 MHZ ',' 25 MHZ ',' 33 MHZ ',' 40 MHZ ',' 50 MHZ ',' 66 MHZ '}
Local oRadButton := nil
Local nButton    := 1
Local oBrowseBox := nil
Local oBrowse    := TBrowseDb(0,0,4,19)
Local oColumn    := nil
Local oName      := nil
Local cName      := space(20)
Local aMenu      := {}
Local oMenu      := nil
Local lVar       := .f.
Local oCheckBox  := nil


   //--------------------------
   //  Make a DialogBox 18x70
   //--------------------------
   @ 3,10 Get as DialogBox                  ;
	 Header 'TYPES OF CONTROLS'              ;
    Height 18                               ;
    Length 61
    //Color 'W/B'

      //-------------------------
      //  Use the test database
      //-------------------------
      use test.dbf alias test new index test.ntx

   Do Case

   Case nType == 1

      @ 3,4 Say Text "@ 12,22 get as pushbutton oButton             ;"
      @ 4,4 Say Text "         Prompt '~Press Button'               ;"
      @ 5,4 Say Text "         Color 'W/B'                          ;"
      @ 6,4 Say Text "         HotKey K_ALT_P                       ;"
      @ 7,4 Say Text "         Action {|oGet| oGet:exitstate := GE_ESCAPE }"

   Case nType == 2

      @ 2,10 Get cDate As Spinner                    ;
			 Prompt 'D~ate..........:'  ;
			 Count  bCount1             ;
			 Picture '@D'               ;
          HotKey K_ALT_A

      @ 4,10 Say Text "@ 2,10 Get cDate As Spinner         ;"
      @ 5,10 Say Text "         Prompt 'D~ate..........:'  ;"
      @ 6,10 Say Text "         Count  bCount1             ;"
      @ 7,10 Say Text "         Picture '@D'               ;"
      @ 8,10 Say Text "         Color 'W/B'                ;"
      @ 9,10 Say Text "         HotKey K_ALT_A              "

   Case nType == 3

      //-------------------------------------------
      //  Create DropDown box for different types
      //  of Computers...
      //-------------------------------------------
      @ 2,10 Get cComputer As DropDown oCPUType     ;
			 Prompt 'Computer ~Type.:'  ;
			 Array aComputer            ;
			 DropDown Width 14          ;
			 DropDown Height 3          ;
          HotKey K_ALT_T


      @ 4,8 Say Text "@ 2,10 Get cComputer As DropDown oCPUType ;"
      @ 5,8 Say Text "       Prompt 'Computer ~Type.:'          ;"
      @ 6,8 Say Text "       Array aComputer                    ;"
      @ 7,8 Say Text "       DropDown Width 14                  ;"
      @ 8,8 Say Text "       DropDown Height 3                  ;"
      @ 9,8 Say Text "       HotKey K_ALT_T                     ;"
      @ 10,8 Say Text "       Color 'W/B'                         "

   Case nType == 4

      @ 3,15 Say Text "@ 3,2 Get nButton As RadioButton oRadButton ;"
      @ 4,15 Say Text "      Array  aRadio                         ;"
      @ 5,15 Say Text "      Prompt 'CPU ~Speed:'                  ;"
      @ 6,15 Say Text "      Color 'W/B'                           ;"
      @ 7,15 Say Text "      HotKey K_ALT_S                         "

      @ 3,2 Get nButton As RadioButton oRadButton  ;
	    Array  aRadio                           ;
	    Prompt 'CPU ~Speed:'                    ;
       HotKey K_ALT_S

   Case nType == 5

      @ 2,10  Get cName As TextField oName           ;
			 Prompt "~Enter Name....:"  ;
			 Picture '@K'               ;
          HotKey K_ALT_E

      @ 4,10 Say Text "@ 2,10 Get cName As TextField oName ;"
      @ 5,10 Say Text "       Prompt '~Enter Name....:'    ;"
      @ 6,10 Say Text "       Picture '@K'                 ;"
      @ 7,10 Say Text "       Color 'W/B'                  ;"
      @ 8,10 Say Text "       HotKey K_ALT_E                "

   Case nType == 6
      //---------------------------
      //  Create a TBrowse Object
      //---------------------------
      oColumn := TBColumnNew()
      oColumn:Block := {|| test->Name }
      oBrowse:addcolumn(oColumn)

      //------------------------------------------
      //  Create a BrowseBox that contains names
      //  of people...
      //------------------------------------------
      @ 2,2 Get as BrowseBox  oBrowseBox       ;
	    Prompt " ~Select Name:"                 ;
	    Browse oBrowse                          ;
	    Height 8                                ;
	    Length 22                               ;
       Hotkey K_ALT_S


      @ 2,24 Say Text "@ 2,2 Get as BrowseBox oBrowseBox ;"
      @ 3,24 Say Text "      Prompt ' ~Select Name:'     ;"
      @ 4,24 Say Text "      Browse oBrowse              ;"
      @ 5,24 Say Text "      Height 8                    ;"
      @ 6,24 Say Text "      Length 25                   ;"
      @ 7,24 Say Text "      Hotkey K_ALT_S              ;"
      @ 8,24 Say Text "      Color 'W/B'                  "

   Case nType == 7

      @ 2,10  Get lVar As Checkbox oCheckBox         ;
			 Prompt ' Check This ~Box!' ;
          Hotkey K_ALT_B

      @ 4,10 Say Text "@ 2,10  Get lVar As Checkbox oCheckBox ;"
      @ 5,10 Say Text "       Prompt ' Check This ~Box!'      ;"
      @ 6,10 Say Text "       Color 'W/B'                     ;"
      @ 7,10 Say Text "       Hotkey K_ALT_B                   "

   Case nType == 8

      @ 3,4 Say Text  "Create Menu oMenu"
      @ 4,4 Say Text  "@ Column 1 Create Menu Option 'Main' Using aMenu    "
      @ 5,4 Say Text  "  Create Item 'File    ' Attach to aMenu            "
      @ 6,4 Say Text  "     Create Sub Item 'Open  ' Attach to aMenu     ; "
      @ 7,4 Say Text  "     Action {|nExitState| nExitstate := GE_NOEXIT } "
      @ 8,4 Say Text  "     Create Sub Item 'Close ' Attach to aMenu     ; "
      @  9,4 Say Text "     Action {|nExitState| nExitstate := GE_NOEXIT } "
      @ 10,4 Say Text "  Create Separator Attach to aMenu                  "
      @ 11,4 Say Text "  Create Item 'Cancel  ' Attach to aMenu          ; "
      @ 12,4 Say Text "  Action {|oGet| oGet:exitstate := GE_LEAVESUBMENU} "
      @ 13,4 Say Text "Attach aMenu to oMenu"

      Create Menu oMenu
      @ Column 1  Create Menu Option 'Main' Using aMenu

      Create Item 'File    ' Attach to aMenu
      Create Sub Item 'Open    ' Attach to aMenu         ;
        Action {|nExitState| Help(H_NOTDONE), nExitstate := GE_NOEXIT }
      Create Sub Item 'Close   ' Attach to aMenu         ;
        Action {|nExitState| Help(H_NOTDONE), nExitState := GE_NOEXIT }

      Create Separator Attach to aMenu
      Create Item 'Cancel  ' Attach to aMenu             ;
	     Action {|oGet| oGet:exitstate := GE_LEAVESUBMENU }

      @ Column 56 Create Menu Option 'Exit' Using aMenu  ;
        Action {|oGet| oGet:exitstate := GE_ESCAPE }

      Attach aMenu to oMenu

   End Case

   @ 15,23 get as pushbutton oButton        ;
	 Prompt "~Press Button"                  ;
    HotKey K_ALT_P                          ;
	 Action {|oGet| oGet:exitstate := GE_ESCAPE }

   Read

   Kill DialogBox
   test->(dbclosearea())

Return nil

//=============================================================================
// Function    - ChangeView
// Description -
// See also    -
// Created     - RTD  04/30/94  08:15 am
// Revised     - RTD  04/30/94  08:15 am
//
// Format      - ChangeView( agetlist )
//
// Parameters  - agetlist :
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Examples    -
//
// Changes/Fixes:
//
//=============================================================================
Function ChangeView(agetlist)
Local nCount := 1

   if Box:cColor == "W/B"
      Box:cColor := "W/R"
      Box:cHeader := "NEW DIALOGBOX"
   else
      Box:cColor := "W/B"
      Box:cHeader := "OLD DIALOGBOX"
   endif
   for nCount := 1 to len(aGetlist)
	  if aGetList[nCount]:name != "MENU"
	  	  aGetlist[nCount]:cColor := Box:cColor
          if aGetList[nCount]:name == "BROWSEBOX"
             aGetList[nCount]:oBrowse:colorspec := Box:cColor
          endif
      endif
   next

   RedrawBox(aGetList)

Return Nil

//=============================================================================
// Function    - Help
// Description -
// See also    -
// Created     - RTD  09/05/94  13:38:45
// Revised     - RTD  09/05/94  13:38:45
//
// Format      - Help( aHelpLine, nMore )
//
// Parameters  - aHelpLine :
//               nMore     :
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Changes/Fixes:
//
//=============================================================================
Function Help(cKey)
	Local aHelp := {}
	Local cColor := "W/R"
	Local cHeader := "HELP"

	if cKey == H_MENU
		aadd(aHelp,"You can use the Mouse or Keyboard to Navigate thru the")
		aadd(aHelp,"Menu System.  The Right and Left arrows will move you ")
		aadd(aHelp,"across the Menu Selections and the Up and Down arrows ")
		aadd(aHelp,"will move you Up and Down the Menu Sub Items.         ")
	elseif cKey == H_ABOUT
		cHeader := "ABOUT"
		aHelp := aAbout
	elseif cKey == H_BROWSE
	   aadd(aHelp,"This is called a BrowseBox.  To navigate thru this, you can")
		aadd(aHelp,"use the Mouse or Keyboard.  The navigation is similar to   ")
		aadd(aHelp,"all other Browses, For Example:                            ")
		aadd(aHelp,"")
		aadd(aHelp,"K_UP         -  oBrowse:up()      ")
		aadd(aHelp,"K_DOWN       -  oBrowse:Down()    ")
		aadd(aHelp,"K_PGDN       -  oBrowse:pageDown()")
		aadd(aHelp,"K_PGUP       -  oBrowse:pageUp()  ")
		aadd(aHelp,"K_CTRL_PGDN  -  oBrowse:goBottom()")
		aadd(aHelp,"K_CTRL_PGUP  -  oBrowse:goTop()   ")
		aadd(aHelp,"")
		aadd(aHelp,"Get the Picture!")
	elseif cKey == H_ADD
		aadd(aHelp,"If you press this button, you will be")
		aadd(aHelp,"able to add to the client file.")
	elseif cKey == H_EDIT
		aadd(aHelp,"If you press this button, you will be")
		aadd(aHelp,"able to edit the current hi-lighted")
		aadd(aHelp,"client in the Client BrowseBox")
	elseif cKey == H_CHANGE
		aadd(aHelp,"Press this button and watch the colors change.")
	elseif cKey == H_CLOSE
		aadd(aHelp,"Press this button and exit the dialog box.")
	elseif cKey == H_NAME
		aadd(aHelp,"Input Name of Client")
	elseif cKey == H_ADDRESS
		aadd(aHelp,"Input Address of Client")
	elseif cKey == H_PHONE
		aadd(aHelp,"Input Phone Number of Client")
	elseif cKey == H_OK
		aadd(aHelp,"Hit the OK Button to Select Client")
	elseif cKey == H_CLIENTDATA
		aadd(aHelp,"This is the Client Data Screen.  Edit the Information    ")
		aadd(aHelp,"on the screen, and when you are ready, Hit the OK button ")
		aadd(aHelp,"to save the information.  Remember, there are some       ")
		aadd(ahelp,"validations on this screen that will be checked prior    ")
		aadd(aHelp,"to saving.  If you have any questions on each field, just")
		aadd(aHelp,"press the F1 Key for help                                ")
		aadd(aHelp,"")
		aadd(aHelp," * Note:  Not all fields have help for them")
        elseif cKey == H_NOTDONE
                cHeader := "WORK IN PROGRESS"
                aadd(aHelp,"This option is not completed yet!")
	else
		aadd(aHelp,"No Help Found!")
	endif
	msg_box(nil,nil,aHelp,cHeader,nil,cColor)

Return nil

//=============================================================================
// Function    - SelectClient
// Description -
// See also    -
// Created     - RTD  09/11/94  10:38 pm
// Revised     - RTD  09/11/94  10:38 pm
//
// Format      - SelectClient( oMenu )
//
// Parameters  - oMenu :
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Examples    -
//
// Changes/Fixes:
//
//=============================================================================
Function SelectClient()
Local Getlist    := {}
Local nRecNo     := nRecord
Local oBrowse    := TBrowseDB(0,0,0,0)
Local oBrowseBox := nil
Local oColumn    := nil
Local oButton    := nil
Local cHeader    := "SELECT CLIENT"

   //-------------------------
   //  Use the test database
   //-------------------------
   use test.dbf alias test new index test.ntx

   //---------------------------
   //  Create a TBrowse Object
   //---------------------------
   oColumn := TBColumnNew()
   oColumn:Block := {|| test->Name }
   oBrowse:addcolumn(oColumn)
   oColumn := TbColumnNew()
   oColumn:Block := {|| if(empty(test->phone),padc("No Phone",13),test->phone) }
   oBrowse:addcolumn(oColumn)

   @ 3,5 Get as DialogBox        ;
	  Header cHeader              ;
	  Height 18                   ;
     Length 70

   @  5,43 Say Text 'Name:'    color 'GR+/W'
   @  6,43 Say Text Test->name
   @  7,43 Say Text 'Address:' color 'GR+/W'
   @  8,43 Say Text Test->address
   @  9,43 Say Text 'Phone:'   color 'GR+/W'
   @ 10,43 Say Text Test->phone

   //------------------------------------------
   //  Create a BrowseBox that contains names
   //  of people...
   //------------------------------------------
   @ 2,4 Get as BrowseBox  oBrowseBox        ;
     Prompt " Client ~Name:"                 ;
     Browse oBrowse                          ;
     Height 9                                ;
     Length 36                               ;
     Browse Action {|oGet| updatetext() }    ;
     Hotkey K_ALT_N                          ;
     Help {|| help(H_BROWSE) }               ;
     Vertical Bar Block {|nLength| nLength := test->(lastrec()) };
     Tag Block {|oGet| msg_box(nil,nil,{"You Have Tagged "+alltrim(test->name)},"TAGGED",nil,"N/BG") }

   //----------------------
   //  Create PushButtons
   //----------------------
   @ 15,2 get as pushbutton oButton                       ;
	 Prompt "~OK"                                          ;
    Help {|| help(H_OK) }                                 ;
     Hotkey K_ALT_O,K_ENTER                               ;
     Action {|oGet| nRecNo := test->(recno())            ,;
			oGet:exitstate := GE_ESCAPE            }

   @ 15,59 get as pushbutton oButton        ;
	 Prompt "C~lose"                         ;
    HotKey K_ALT_L,K_ESC                   ;
	 Help {|| help(H_CLOSE) }                ;
	 Action {|oGet| nRecNo := 0, oGet:exitstate := GE_ESCAPE }


   read

   kill dialogbox
   test->(dbclosearea())

return nRecNo

//=============================================================================
// Function    - ShowText
// Description -
// See also    -
// Created     - RTD  10/21/94  02:37 pm
// Revised     - RTD  10/21/94  02:37 pm
//
// Format      - ShowText()
//
// Parameters  - None.
//
// Returns     -
//
// Usage       -
//
// Notes       -
//
// Examples    -
//
// Changes/Fixes:
//
//=============================================================================
Function ShowText()
Local cfile   := "REPORT.TXT"
   setcutandpaste(.t.)
   FileViewer(cFile,nBoxTop+3,nBoxLeft+3,nBoxBot-2,nBoxRight-3,nil,{|| Help(H_NOTDONE) },{"F2-Printer",nil,K_F2,{|| Help(H_NOTDONE) }})
Return nil

//== Function ==================================================================
//         Name: IsTrue()              Docs: Raymond T. Deal
//  Description:
//       Author: Raymond T. Deal
// Date created: 10-30-95              Date updated: 10-30-95
// Time created: 08:27:17am            Time updated: 08:27:17am
//    Copyright: Raymond T. Deal
//------------------------------------------------------------------------------
//    Arguments: None
// Return Value: .f.
//     See Also:
//==============================================================================
Function IsTrue()

Return .f.


//== Function ==================================================================
//         Name: Bar()                 Docs: Raymond T. Deal
//  Description:
//       Author: Raymond T. Deal
// Date created: 12-11-95              Date updated: 12-11-95
// Time created: 11:31:34am            Time updated: 11:31:34am
//    Copyright: Raymond T. Deal
//------------------------------------------------------------------------------
//    Arguments: nWhich
// Return Value: nil
//     See Also:
//==============================================================================
Function Bar(nWhich)
  // 0 = All Bars
  // 1 = Horizontal Bar
  // 2 = Vertical Bar
  // 3 = Status Bar


  Local nCount := 1
  Local cHeader := "HORIZONTAL/VERTICAL/STATUS BAR"
  Local cColor := "N/BG"


  if nWhich == 1
      cHeader := "HORIZONTAL BAR"
  elseif nWhich == 2
      cHeader := "VERTICAL BAR"
  elseif nWhich == 3
      cHeader := "STATUS BAR"
  endif

  // Use the StatusBar's Dialog Box
  statusbar(.t.,cHeader,cColor)

  for nCount := 0 to 1000

     if nWhich == 1 .or. nWhich == 0
        HorizontalBar(nCount,1000,cColor)
     endif
     if nWhich == 2 .or. nWhich == 0
        VerticalBar(nCount,1000,cColor)
     endif
     if nWhich == 3 .or. nWhich == 0
        Statusbar(nCount,1000,cColor)
     endif
     @ 0,0 Say Text str(nCount,4) color "N+/W*"

  next

  inkey(1)
  for nCount := 1000 to 0 step -1
     if nWhich == 1 .or. nWhich == 0
        HorizontalBar(nCount,1000,cColor)
     endif
     if nWhich == 2 .or. nWhich == 0
        VerticalBar(nCount,1000,cColor)
     endif
     if nWhich == 3 .or. nWhich == 0
        Statusbar(nCount,1000,cColor,nil,nil,nil,.t.)
     endif


     @ 0,0 Say Text str(nCount,4) color "N+/W*"
  next

  inkey(1)
  statusbar(.f.)
Return nil
